package com.tzld.piaoquan.recommend.server.service.recall.strategy;

import com.tzld.piaoquan.recommend.server.service.recall.RecallParam;
import org.springframework.stereotype.Service;

/**
 * @author dyp
 */
@Service
public class FlowPoolWithScoreRecallStrategy extends AbstractFlowPoolWithScoreRecallStrategy {

    @Override
    String flowPoolKey(RecallParam param) {
        return String.format("flow:pool:item:score:%s", param.getAppType());
    }

    @Override
    String pushFrom() {
        return "flow_pool";
    }
}
